'  ------------------------------------------------------------------------------------
'  irr::core::array<S3DVertex> wrappers
'  NOTES:
'  - for regular data types use Var IrrCore_() to get the actual value
'  - did not implement:
	'Function IrrCore_Array_S3DVertex_linear_reverse_search:Int(parray_S3DVertex_arr:Int,find:Int)
	'Function IrrCore_Array_S3DVertex_linear_search:Int(parray_S3DVertex_arr:Int,find:Int)
	'Function IrrCore_Array_S3DVertex_binary_search:Int(parray_S3DVertex_arr:Int,find:Int)
	'Function IrrCore_Array_S3DVertex_binary_searchWithBounds:Int(parray_S3DVertex_arr:Int,find:Int,nLeft:Int,nRight:Int)
	'Function IrrCore_Array_S3DVertex_sort(parray_S3DVertex_arr:Int)
	'Function IrrCore_Array_S3DVertex_const_pointer:Int(parray_S3DVertex_arr:Int)
	'Function IrrCore_Array_S3DVertex_pointer:Int(parray_S3DVertex_arr:Int)
	'Function IrrCore_Array_S3DVertex_set_pointer(parray_S3DVertex_arr:Int,newPointer:Int,size:Int)
'  ------------------------------------------------------------------------------------

Public

Type Array_S3DVertex Extends IrrBase Final

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function createWithSize:Array_S3DVertex(start_count:Int)
		Return createFromHandle(IrrCore_Array_S3DVertex_newWithSize(start_count))
	EndFunction
	
	Function createFromOther:Array_S3DVertex(other:Array_S3DVertex)
		Return createFromHandle(IrrCore_Array_S3DVertex_newFromOther(other.handle))
	EndFunction

	Function create:Array_S3DVertex()
		Return createFromHandle(IrrCore_Array_S3DVertex_new())
	EndFunction
	
	Function createFromHandle:Array_S3DVertex(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:Array_S3DVertex=New Array_S3DVertex
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Array_S3DVertex_del(handle)
	EndMethod	

	'--------------------------------------------
	' the rest
	'--------------------------------------------
	
	Method allocated_size:Int()
		Return IrrCore_Array_S3DVertex_allocated_size(handle)
	EndMethod

	Method clear()
		IrrCore_Array_S3DVertex_clear(handle)
	EndMethod

	Method empty:Int()
		Return IrrCore_Array_S3DVertex_empty(handle)
	EndMethod
	
	Method eraseWithCount(idx:Int,count:Int)
		IrrCore_Array_S3DVertex_eraseWithCount(handle,idx,count)
	EndMethod
	
	Method erase(idx:Int)
		IrrCore_Array_S3DVertex_erase(handle,idx)
	EndMethod

	Method reallocate(new_size:Int)
		IrrCore_Array_S3DVertex_reallocate(handle,new_size)
	EndMethod
	
	Method set_free_when_destroyed(bNewVal:Int)
		IrrCore_Array_S3DVertex_set_free_when_destroyed(handle,bNewVal)
	EndMethod

	Method set_sorted(bVal:Int)
		IrrCore_Array_S3DVertex_set_sorted(handle,bVal)
	EndMethod
	
	Method set_used(used:Int)
		IrrCore_Array_S3DVertex_set_used(handle,used)
	EndMethod
	
	Method size:Int()
		Return IrrCore_Array_S3DVertex_size(handle)
	EndMethod

	Method getLast:S3DVertex()
		'  do Not Delete this pointer
		Return S3DVertex.createFromHandle(IrrCore_Array_S3DVertex_getLast(handle),False)
	EndMethod

	Method elementAt:S3DVertex(idx:Int)
		'  do Not Delete this pointer
		Return S3DVertex.createFromHandle(IrrCore_Array_S3DVertex_elementAt(handle,idx),False)
	EndMethod
	
	Method insert(element:S3DVertex,idx:Int=0)
		IrrCore_Array_S3DVertex_insert(handle,element.handle,idx)
	EndMethod

	Method Eq(other:Array_S3DVertex)
		IrrCore_Array_S3DVertex_Eq(handle,other.handle)
	EndMethod

	Method push_back(element:S3DVertex)
		IrrCore_Array_S3DVertex_push_back(handle,element.handle)
	EndMethod
	
	Method push_front(element:S3DVertex)
		IrrCore_Array_S3DVertex_push_front(handle,element.handle)
	EndMethod
		
EndType




