' ------------------------------------------------------------------------------------
' irr::core::rect<f32> wrappers (done)
' ------------------------------------------------------------------------------------

Public

Type Rectf Extends IrrBase Final

	Method Eq(other:Rectf)
		IrrCore_Rectf_Eq(handle,other.handle)
	EndMethod
	Method PlusEq:Rectf(other:Rectf)
		IrrCore_Rectf_PlusEq(handle,other.handle)
		Return Self
	EndMethod
	Method Plus:Rectf(other:Rectf)
		Return createFromHandle(IrrCore_Rectf_Plus(handle,other.handle),True)
	EndMethod
	Method MinusEq:Rectf(other:Rectf)
		IrrCore_Rectf_PlusEq(handle,other.handle)
		Return Self
	EndMethod
	Method Minus:Rectf(other:Rectf)
		Return createFromHandle(IrrCore_Rectf_Plus(handle,other.handle),True)
	EndMethod
	Method EqEq:Int(other:Rectf)
		Return IrrCore_Rectf_EqEq(handle,other.handle)
	EndMethod
	Method NotEq:Int(other:Rectf)
		Return IrrCore_Rectf_NotEq(handle,other.handle)
	EndMethod

	Method isPointInside:Int(pPos:Position2df)
		Return IrrCore_Rectf_isPointInside(handle,pPos.handle)
	EndMethod
	Method isRectCollided:Int(other:Rectf)
		Return IrrCore_Rectf_isRectCollided(handle,other.handle)
	EndMethod
	Method clipAgainst(other:Rectf)
		IrrCore_Rectf_clipAgainst(handle,other.handle) 
	EndMethod
	Method getWidth:Float()
		Return IrrCore_Rectf_getWidth(handle)
	EndMethod
	Method getHeight:Float()
		Return IrrCore_Rectf_getHeight(handle)
	EndMethod
	Method repair()
		IrrCore_Rectf_repair(handle) 
	EndMethod
	Method isValid:Int()
		Return IrrCore_Rectf_isValid(handle)
	EndMethod
	Method getCenter:Position2df()
		Return Position2df.createFromHandle(IrrCore_Rectf_getCenter(handle))
	EndMethod
	Method getUpperLeftCorner:Position2df()
		' dont delete
		Return Position2df.createFromHandle(IrrCore_Rectf_getUpperLeftCorner(handle),False)
	EndMethod
	Method getLowerRightCorner:Position2df()
		' dont delete
		Return Position2df.createFromHandle(IrrCore_Rectf_getLowerRightCorner(handle),False)
	EndMethod
	Method getSize:Dimension2df()
		Return Dimension2df.createFromHandle(IrrCore_Rectf_getSize(handle))
	EndMethod	
	Method addInternalPointFromPos(pos:Position2df)
		IrrCore_Rectf_addInternalPointFromPos(handle,pos.handle)
	EndMethod	
	Method addInternalPoint(x:Float,y:Float)
		IrrCore_Rectf_addInternalPoint(handle,x,y)
	EndMethod

	Method getArea:Float()
		Return IrrCore_Rectf_getArea(handle)
	EndMethod
	
	Method constrainTo:Int(other:Rectf)
		Return IrrCore_Rectf_constrainTo(handle,other.handle)
	EndMethod
	
	Method Less:Int(other:Rectf)
		Return IrrCore_Rectf_Less(handle,other.handle)
	EndMethod

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function create:Rectf()
		Return createFromHandle(IrrCore_Rectf_new())
	EndFunction

	Function createFromVals:Rectf(x1:Float=0,y1:Float=0,x2:Float=0,y2:Float=0)
		Return createFromHandle(IrrCore_Rectf_newFromVals(x1,y1,x2,y2))
	EndFunction

	Function createFromPos:Rectf(pUpperLeft:Position2df,pLowerRight:Position2df)
		Return createFromHandle(IrrCore_Rectf_newFromPos(pUpperLeft.handle,pLowerRight.handle))
	EndFunction

	Function createFromPosSize:Rectf(pPos:Position2df,pSize:Dimension2df)
		Return createFromHandle(IrrCore_Rectf_newFromPosSize(pPos.handle,pSize.handle))
	EndFunction

	Function createFromRect:Rectf(pRect:Rectf)
		Return createFromHandle(IrrCore_Rectf_newFromRect(pRect.handle))
	EndFunction
	
	Function createFromHandle:Rectf(pRect:Int,bMustDel:Int=True)
		If Not pRect Then Return Null
		Local oRetVal:Rectf=New Rectf
		oRetVal.attach(pRect,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Rectf_del(handle)
	EndMethod	
EndType
