'-------------------------------------------------
' IAttributes wrapper
'-------------------------------------------------

Extern
	'! Removes all attributes
	Function Irr_IAttributes_clear(pIAttributes:Int)
	'! Adds an attribute as integer
	Function Irr_IAttributes_addInt(pIAttributes:Int,attributeName$z, value:Int)
	'! Adds an attribute as float
	Function Irr_IAttributes_addFloat(pIAttributes:Int,attributeName$z, value:Float)
	'! Adds an attribute as string
	Function Irr_IAttributes_addString(pIAttributes:Int,attributeName$z, value$z)
	'! Adds an attribute as bool
	Function Irr_IAttributes_addBool(pIAttributes:Int,attributeName$z, bValue:Int)
	'! Adds an attribute as enum
	Function Irr_IAttributes_addStringEnum(pIAttributes:Int,attributeName$z, enumValue$z, enumerationLiterals:Byte Ptr Ptr)
	'! Adds an attribute as enum
	Function Irr_IAttributes_addIntEnum(pIAttributes:Int,attributeName$z, enumValue:Int, enumerationLiterals:Byte Ptr Ptr)
	'! Adds an attribute as color
	Function Irr_IAttributes_addColor(pIAttributes:Int,attributeName$z, pSColor:Int)
	'! Adds an attribute as floating point color
	Function Irr_IAttributes_addColorf(pIAttributes:Int,attributeName$z, pSColorf:Int)
	'! Adds an attribute as 3d vector
	Function Irr_IAttributes_addVector3df(pIAttributes:Int,attributeName$z, pVector3df:Int)
	'! Adds an attribute as 2d position
	Function Irr_IAttributes_addPosition2di(pIAttributes:Int,attributeName$z, pPosition2di:Int)
	'! Adds an attribute as binary data
	Function Irr_IAttributes_addBinary(pIAttributes:Int,attributeName$z, pVoid_data:Byte Ptr, dataSizeInBytes:Int)
	'! Adds an attribute as texture reference
	Function Irr_IAttributes_addTexture(pIAttributes:Int,attributeName$z, pITexture:Int)
	'! Returns amount of attributes in this collection of attributes.
	Function Irr_IAttributes_getAttributeCount:Int(pIAttributes:Int)
	'! Returns attribute name by index. 
	'! \param index: Index value, must be between 0 and getAttributeCount()-1.
	Function Irr_IAttributes_getAttributeName$z(pIAttributes:Int,index:Int)
	'! Returns the type of an attribute
	'! \param attributeName: Name for the attribute
	Function Irr_IAttributes_getAttributeTypeByName:Int(pIAttributes:Int,attributeName$z)
	'! Returns attribute type by index. 
	'! \param index: Index value, must be between 0 and getAttributeCount()-1.
	Function Irr_IAttributes_getAttributeTypeByIndex:Int(pIAttributes:Int,index:Int)
	'! Sets an attribute value as string. 
	'! \param attributeName: Name for the attribute
	'! \param value: Value for the attribute. Set this to 0 to delete the attribute
	Function Irr_IAttributes_setStringAttributeByName(pIAttributes:Int,attributeName$z, value$z)
	'! Gets an attribute as string.
	'! \param attributeName: Name of the attribute to get.
	'! \return Returns value of the attribute previously set by setAttribute() 
	'! or 0 if attribute is not set.
	Function Irr_IAttributes_getAttributeAsStringByName$z(pIAttributes:Int,attributeName$z)
	'! Returns attribute value as string by index. 
	'! \param index: Index value, must be between 0 and getAttributeCount()-1.
	Function Irr_IAttributes_getAttributeAsStringByIndex$z(pIAttributes:Int,index:Int)	
	'! Sets an attribute as boolean value
	Function Irr_IAttributes_setBoolAttributeByName(pIAttributes:Int,attributeName$z, bValue:Int)
	'! Gets an attribute as boolean value
	'! \param attributeName: Name of the attribute to get.
	'! \return Returns value of the attribute previously set by setAttribute()
	Function Irr_IAttributes_getAttributeAsBoolByName:Int(pIAttributes:Int,attributeName$z)
    '! Gets an attribute as boolean value
	'! \param index: Index value, must be between 0 and getAttributeCount()-1
	Function Irr_IAttributes_getAttributeAsBoolByIndex:Int(pIAttributes:Int,index:Int)
	'! Sets an attribute as integer value
	Function Irr_IAttributes_setIntAttributeByName(pIAttributes:Int,attributeName$z, value:Int)
	'! Gets an attribute as integer value
	'! \param attributeName: Name of the attribute to get.
	'! \return Returns value of the attribute previously set by setAttribute()
	Function Irr_IAttributes_getAttributeAsIntByName:Int(pIAttributes:Int,attributeName$z)
	'! Gets an attribute as integer value
	'! \param index: Index value, must be between 0 and getAttributeCount()-1
	Function Irr_IAttributes_getAttributeAsIntByIndex:Int(pIAttributes:Int,index:Int)
	'! Sets a attribute as float value
	Function Irr_IAttributes_setFloatAttributeByName(pIAttributes:Int,attributeName$z, value:Float)
	'! Gets an attribute as float value
	'! \param attributeName: Name of the attribute to get.
	'! \return Returns value of the attribute previously set by setAttribute()
	Function Irr_IAttributes_getAttributeAsFloatByName:Float(pIAttributes:Int,attributeName$z)
	'! Gets an attribute as float value
	'! \param index: Index value, must be between 0 and getAttributeCount()-1
	Function Irr_IAttributes_getAttributeAsFloatByIndex:Float(pIAttributes:Int,index:Int)
	'! Sets a attribute as color
	Function Irr_IAttributes_setColorAttributeByName(pIAttributes:Int,attributeName$z, pSColor:Int)
	'! Gets an attribute as color
	'! \param attributeName: Name of the attribute to get.
	'! \return Returns value of the attribute previously set by setAttribute()
	' NOTE: must delete ptr
	Function Irr_IAttributes_getAttributeAsColorByName:Int(pIAttributes:Int,attributeName$z) ' returns SColor*
	'! Gets an attribute as color
	'! \param index: Index value, must be between 0 and getAttributeCount()-1
	' NOTE: must delete ptr
	Function Irr_IAttributes_getAttributeAsColorByIndex:Int(pIAttributes:Int,index:Int) ' returns SColor*
	'! Sets a attribute as floating point color
	Function Irr_IAttributes_setSColorfAttributeByName(pIAttributes:Int,attributeName$z, pSColorf:Int)
	'! Gets an attribute as floating point color
	'! \param attributeName: Name of the attribute to get.
	'! \return Returns value of the attribute previously set by setAttribute()
	' NOTE: must delete ptr
	Function Irr_IAttributes_getAttributeAsColorfByName:Int(pIAttributes:Int,attributeName$z) ' returns SColorf*
	'! Gets an attribute as floating point color
	'! \param index: Index value, must be between 0 and getAttributeCount()-1
	' NOTE: must delete ptr
	Function Irr_IAttributes_getAttributeAsColorfByIndex:Int(pIAttributes:Int,index:Int) ' returns SColorf*
	'! Sets a attribute as vector
	Function Irr_IAttributes_setVector3dfAttributeByName(pIAttributes:Int,attributeName$z, pVector3df:Int)
	'! Gets an attribute as floating point color
	'! \param attributeName: Name of the attribute to get.
	'! \return Returns value of the attribute previously set by setAttribute()
	Function Irr_IAttributes_getAttributeAsVector3dfByName:Int(pIAttributes:Int,attributeName$z) ' returns vector3df*
	'! Gets an attribute as floating point color
	'! \param index: Index value, must be between 0 and getAttributeCount()-1.
	Function Irr_IAttributes_getAttributeAsVector3dfByIndex:Int(pIAttributes:Int,index:Int) ' returns vector3df*
	Function Irr_IAttributes_setPosition2diAttributeByName(pIAttributes:Int,attributeName$z, pPositiondi:Int)
	Function Irr_IAttributes_getAttributeAsPosition2diByName:Int(pIAttributes:Int,attributeName$z) ' returns position2di*
	Function Irr_IAttributes_getAttributeAsPosition2diByIndex:Int(pIAttributes:Int,index:Int) ' returns position2di*
	'! Sets an attribute as binary data
	Function Irr_IAttributes_setBinaryAttributeByName(pIAttributes:Int,attributeName$z, pVoid_data:Byte Ptr, dataSizeInBytes:Int )
	'! Gets an attribute as binary data
	'! \param attributeName: Name of the attribute to get.
	Function Irr_IAttributes_getAttributeAsBinaryDataByName(pIAttributes:Int,attributeName$z, pVoid_outData:Byte Ptr, maxSizeInBytes:Int)
	'! Gets an attribute as binary data
	'! \param index: Index value, must be between 0 and getAttributeCount()-1
	Function Irr_IAttributes_getAttributeAsBinaryDataByIndex(pIAttributes:Int,index:Int, pVoid_outData:Byte Ptr, maxSizeInBytes:Int)
	'! Sets an attribute as enumeration
	Function Irr_IAttributes_setEnumAttributeByName(pIAttributes:Int,attributeName$z, enumValue$z, enumerationLiterals:Byte Ptr Ptr)
	'! Gets an attribute as enumeration
	'! \param attributeName: Name of the attribute to get.
	'! \return Returns value of the attribute previously set by setAttribute()
	Function Irr_IAttributes_getAttributeAsStringEnumerationByName$z(pIAttributes:Int,attributeName$z)
	'! Gets an attribute as enumeration
	'! \param attributeName: Name of the attribute to get.
	'! \param enumerationLiteralsToUse: Use these enumeration literals to get the index value instead of the set ones.
	'! This is useful when the attribute list maybe was read from an xml file, and only contains the enumeration string, but
	'! no information about its index.
	'! \return Returns value of the attribute previously set by setAttribute()
	Function Irr_IAttributes_getAttributeAsIntEnumerationByName:Int(pIAttributes:Int,attributeName$z, enumerationLiteralsToUse:Byte Ptr Ptr)
	'! Gets an attribute as enumeration
	'! \param index: Index value, must be between 0 and getAttributeCount()-1.
	Function Irr_IAttributes_getAttributeAsIntEnumerationByIndex:Int(pIAttributes:Int,index:Int, enumerationLiteralsToUse:Byte Ptr Ptr)
	'! Gets an attribute as enumeration
	'! \param index: Index value, must be between 0 and getAttributeCount()-1.
	Function Irr_IAttributes_getAttributeAsStringEnumerationByIndex$z(pIAttributes:Int,index:Int)
	'! Gets the list of enumeration literals of an enumeration attribute 
	'! \param attributeName: Name of the attribute to get.
	Function Irr_IAttributes_getAttributeEnumerationLiteralsOfEnumerationByName(pIAttributes:Int,attributeName$z,pStringc_outLiterals:Int Ptr)
	'! Gets the list of enumeration literals of an enumeration attribute 
	'! \param index: Index value, must be between 0 and getAttributeCount()-1.
	Function Irr_IAttributes_getAttributeEnumerationLiteralsOfEnumerationByIndex(pIAttributes:Int,index:Int,pStringc_outLiterals:Int Ptr)
	'! Sets an attribute as texture reference
	Function Irr_IAttributes_setTextureAttributeByName(pIAttributes:Int,attributeName$z, pITexture:Int )
	'! Gets an attribute as texture reference
	'! \param attributeName: Name of the attribute to get.
	' NOTE: need to delete
	Function Irr_IAttributes_getAttributeAsTextureByName:Int(pIAttributes:Int,attributeName$z) ' returns ITexture*
	'! Gets an attribute as texture reference
	'! \param index: Index value, must be between 0 and getAttributeCount()-1.
	' NOTE: need to delete
	Function Irr_IAttributes_getAttributeAsTextureByIndex:Int(pIAttributes:Int,index:Int) ' returns ITexture*
	'! Returns if an attribute with a name exists
	Function Irr_IAttributes_existsAttribute:Int(pIAttributes:Int,attributeName$z)
	'! Returns attribute index from name, -1 if not found
	Function Irr_IAttributes_findAttribute:Int(pIAttributes:Int,attributeName$z)
	'! Sets an attribute value as string. 
	'! \param attributeName: Name for the attribute
	Function Irr_IAttributes_setStringAttributeByIndex(pIAttributes:Int,index:Int, value$z)
	'! Sets an attribute as boolean value
	Function Irr_IAttributes_setBoolAttributeByIndex(pIAttributes:Int,index:Int, bValue:Int)
	'! Sets an attribute as integer value
	Function Irr_IAttributes_setIntAttributeByIndex(pIAttributes:Int,index:Int, value:Int)
	'! Sets an attribute as float value
	Function Irr_IAttributes_setFloatAttributeByIndex(pIAttributes:Int,index:Int, value:Float)
	'! Sets an attribute as color
	Function Irr_IAttributes_setColorAttributeByIndex(pIAttributes:Int,index:Int, pSColor:Int)
	'! Sets an attribute as floating point color
	Function Irr_IAttributes_setColorfAttributeByIndex(pIAttributes:Int,index:Int, pSColorf:Int)
	'! Sets an attribute as vector
	Function Irr_IAttributes_setVector3dfAttributeByIndex(pIAttributes:Int,index:Int, pVector3df:Int)
	'! Sets an attribute as binary data
	Function Irr_IAttributes_setBinaryAttributeByIndex(pIAttributes:Int,index:Int, pVoid_data:Byte Ptr, dataSizeInBytes:Int )
	'! Sets an attribute as enumeration
	Function Irr_IAttributes_setEnumAttributeByIndex(pIAttributes:Int,index:Int, enumValue$z, enumerationLiterals:Byte Ptr Ptr)
	'! Sets an attribute as texture reference
	Function Irr_IAttributes_setTextureAttributeByIndex(pIAttributes:Int,index:Int, pITexture:Int)

	Rem

		Rectangle Attribute

	EndRem

	Function Irr_IAttributes_addRect(pIAttributes:Int,attributeName$z, pRecti:Int)
	Function Irr_IAttributes_setRect3diAttributeByName(pIAttributes:Int,attributeName$z, pRecti:Int)
	Function Irr_IAttributes_getAttributeAsRect:Int(pIAttributes:Int,attributeName$z) ' returns core::rect<s32>*
	Function Irr_IAttributes_getAttributeAsRectByIndex:Int(pIAttributes:Int,index:Int) ' returns core::rect<s32>*
	Function Irr_IAttributes_setRect3diAttributeByIndex(pIAttributes:Int,index:Int, pRecti:Int)

	Rem

		matrix attribute

	EndRem 

	Function Irr_IAttributes_addMatrix(pIAttributes:Int,attributeName$z,pMatrix4:Int)
	Function Irr_IAttributes_setMatrixAttributeByName(pIAttributes:Int,attributeName$z,pMatrix4:Int)
	Function Irr_IAttributes_getAttributeAsMatrixByName:Int(pIAttributes:Int,attributeName$z) ' returns core::matrix4*
	Function Irr_IAttributes_getAttributeAsMatrixByIndex:Int(pIAttributes:Int,index:Int) ' returns core::matrix4*
	Function Irr_IAttributes_setMatrixAttributeByIndex(pIAttributes:Int,index:Int,pMatrix4:Int)

	Rem
		quaternion attribute

	EndRem

	Function Irr_IAttributes_addQuaternion(pIAttributes:Int,attributeName$z,pQuaternion:Int)
	Function Irr_IAttributes_setQuaternionAttributeByName(pIAttributes:Int,attributeName$z,pQuaternion:Int)
	Function Irr_IAttributes_getAttributeAsQuaternionByName:Int(pIAttributes:Int,attributeName$z) ' returns core::quaternion*
	Function Irr_IAttributes_getAttributeAsQuaternionByIndex:Int(pIAttributes:Int,index:Int) ' returns core::quaternion*
	Function Irr_IAttributes_setQuaternionAttributeByIndex(pIAttributes:Int,index:Int,pQuaternion:Int)

	Rem

		3d bounding box

	EndRem

	Function Irr_IAttributes_addBox3d(pIAttributes:Int,attributeName$z,pAABbox3df:Int)
	Function Irr_IAttributes_setAABbox3dfAttributeByName(pIAttributes:Int,attributeName$z,pAABbox3df:Int)
	Function Irr_IAttributes_getAttributeAsBox3dByName:Int(pIAttributes:Int,attributeName$z) ' returns core::aabbox3df*
	Function Irr_IAttributes_getAttributeAsBox3dByIndex:Int(pIAttributes:Int,index:Int) ' returns core::aabbox3df*
	Function Irr_IAttributes_setAABbox3dfAttributeByIndex(pIAttributes:Int,index:Int,pAABbox3df:Int)

	Rem

		plane

	EndRem

	Function Irr_IAttributes_addPlane3d(pIAttributes:Int,attributeName$z,pPlane3df:Int)
	Function Irr_IAttributes_setPlane3dfAttributeByName(pIAttributes:Int,attributeName$z,pPlane3df:Int)
	Function Irr_IAttributes_getAttributeAsPlane3dByName:Int(pIAttributes:Int,attributeName$z) ' returns core::plane3df*
	Function Irr_IAttributes_getAttributeAsPlane3dByIndex:Int(pIAttributes:Int,index:Int) ' returns core::plane3df*
	Function Irr_IAttributes_setPlane3dfAttributeByIndex(pIAttributes:Int,index:Int,pPlane3df:Int)

	Rem

		3d triangle

	EndRem

	Function Irr_IAttributes_addTriangle3d(pIAttributes:Int,attributeName$z,pTriangle3df:Int)
	Function Irr_IAttributes_setTriangle3dfAttributeByName(pIAttributes:Int,attributeName$z,pTriangle3df:Int)
	Function Irr_IAttributes_getAttributeAsTriangle3dByName:Int(pIAttributes:Int,attributeName$z) ' returns core::triangle3df*
	Function Irr_IAttributes_getAttributeAsTriangle3dByIndex:Int(pIAttributes:Int,index:Int) ' returns core::triangle3df*
	Function Irr_IAttributes_setTriangle3dfAttributeByIndex(pIAttributes:Int,index:Int,pTriangle3df:Int)

	Rem

		line 2d

	EndRem

	'//! Adds an attribute as a 2d line
	Function Irr_IAttributes_addLine2d(pIAttributes:Int,attributeName$z,pLine2df:Int)
	Function Irr_IAttributes_setLine2dfAttributeByName(pIAttributes:Int,attributeName$z,pLine2df:Int)
	Function Irr_IAttributes_getAttributeAsLine2dByName:Int(pIAttributes:Int,attributeName$z) ' returns core::line2df*
	Function Irr_IAttributes_getAttributeAsLine2dByIndex:Int(pIAttributes:Int,index:Int) ' returns core::line2df*
	Function Irr_IAttributes_setLine2dfAttributeByIndex(pIAttributes:Int,index:Int,pLine2df:Int)

	Rem

		line 3d

	EndRem

	Function Irr_IAttributes_addLine3d(pIAttributes:Int,attributeName$z,pLine3df:Int) 
	Function Irr_IAttributes_setLine3dfAttributeByName(pIAttributes:Int,attributeName$z,pLine3df:Int)
	Function Irr_IAttributes_getAttributeAsLine3dByName:Int(pIAttributes:Int,attributeName$z) ' returns core::line3df*
	Function Irr_IAttributes_getAttributeAsLine3dByIndex:Int(pIAttributes:Int,index:Int) ' returns core::line3df*
	Function Irr_IAttributes_setLin3dfAttributeByIndex(pIAttributes:Int,index:Int,pLine3df:Int)


	'! Reads attributes from a xml file.
	'! \param readCurrentElementOnly: If set to true, reading only works if current element has the name 'attributes'.
	'! IF set to false, the first appearing list attributes are read.
	Function Irr_IAttributes_read:Int(pIAttributes:Int,pIXMLReader:Int, bReadCurrentElementOnly:Int=False)
	'! Write these attributes into a xml file
	Function Irr_IAttributes_write:Int(pIAttributes:Int,pIXMLWriter:Int)

	Function Irr_IAttributes_drop:Int(pIAttributes:Int)
	Function Irr_IAttributes_getDebugName$z(pIAttributes:Int)
	Function Irr_IAttributes_grab(pIAttributes:Int)


	Rem
		User Pointer
	Endrem

	Function Irr_IAttributes_addUserPointer(pIAttributes:Int,attributeName$z,userPointer:Byte Ptr)
	Function Irr_IAttributes_setUserPointerAttributeByName(pIAttributes:Int,attributeName$z,userPointer:Byte Ptr)
	Function Irr_IAttributes_getAttributeAsUserPointerByName:Byte Ptr(pIAttributes:Int,attributeName$z)
	Function Irr_IAttributes_getAttributeAsUserPointerByIndex:Byte Ptr(pIAttributes:Int,index:Int)
	Function Irr_IAttributes_setUserPointerAttributeByIndex(pIAttributes:Int,index:Int,userPointer:Byte Ptr)
	
EndExtern



