' ------------------------------------------------------------------------------------
' irr::core::IAnimationEndCallBack wrappers
' ------------------------------------------------------------------------------------

Public

Type IAnimationEndCallBack Extends Tirr_IUnknown

	Function generate:IAnimationEndCallBack()
		Return New IAnimationEndCallBack
	EndFunction

	Method bind(rec:Int) Final
		Super.bind(rec)
		IrrScene_BMXIAnimationEndCallBack_bindOnAnimationEnd( ..
			translate(rec).handle, ..
			OnAnimationEndBinding)
	EndMethod

	Function OnAnimationEndBinding(binding:Int,node:Int) Final
		' get the object whose node is firing
		Local tempobj:IAnimationEndCallBack=IAnimationEndCallBack(translate(binding))
		
		If tempobj<>Null
	  		' get the node
  			Local tempnode:IAnimatedMeshSceneNode=IAnimatedMeshSceneNode.createFromHandle(node,False)
  			' fire the event
	  		tempobj.OnAnimationEnd(tempnode)
		Else
			Throw "Unable to find bound object"
		EndIf
	EndFunction
		
	Method OnAnimationEnd(node:IAnimatedMeshSceneNode)
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_IAnimationEndCallBack_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_IAnimationEndCallBack_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_IAnimationEndCallBack_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
	
	Method getBinderHandle:Int()
		Return IrrScene_BMXIAnimationEndCallBack_getBinder(handle)
	EndMethod
		
	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------
		
	Function create:IAnimationEndCallBack(pGenFunc:Byte Ptr) Final
		Return createFromHandle(pGenFunc,IrrScene_BMXIAnimationEndCallBack_new())
	EndFunction
	
	Function createFromHandle:IAnimationEndCallBack(pGenFunc:Byte Ptr,pHandle:Int,bMustDel:Int=True) Final
		If Not pHandle Then Return Null
		' use the funtion pointer to generate
		Local generate:IAnimationEndCallBack()=pGenFunc
		
		Local oRetVal:IAnimationEndCallBack=generate()

		' turn binding on if this is the first
		oRetVal.bIsBound=bMustDel

		' since this is the first one, this is always mustdel
		oRetVal.attach(pHandle,bMustDel)
		
		Return oRetVal
	EndFunction
	
	Method Destroy()
		IrrScene_BMXIAnimationEndCallBack_del(handle)
	EndMethod	
EndType

