' ------------------------------------------------------------------------------------
'  irr::scene::ICameraSceneNode wrappers (parent is ISceneNode)
' ------------------------------------------------------------------------------------
Public

Type ICameraSceneNode Extends ISceneNodeDefault Final

	Function createFromHandle:ICameraSceneNode(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:ICameraSceneNode=New ICameraSceneNode
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getAspectRatio:Float()
		Return IrrScene_ICameraSceneNode_getAspectRatio(handle)
	EndMethod
	
	Method getFarValue:Float()
		Return IrrScene_ICameraSceneNode_getFarValue(handle)
	EndMethod
	
	Method getFOV:Float()
		Return IrrScene_ICameraSceneNode_getFOV(handle)
	EndMethod
	
	Method getNearValue:Float()
		Return IrrScene_ICameraSceneNode_getNearValue(handle)
	EndMethod
	
	Method getProjectionMatrix:Matrix4()
		Return Matrix4.createFromHandle(IrrScene_ICameraSceneNode_getProjectionMatrix(handle))
	EndMethod
	
	Method getTarget:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_ICameraSceneNode_getTarget(handle))
	EndMethod
	
	Method getUpVector:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_ICameraSceneNode_getUpVector(handle))
	EndMethod
	
	Method getViewMatrix:Matrix4()
		Return Matrix4.createFromHandle(IrrScene_ICameraSceneNode_getViewMatrix(handle))
	EndMethod
	
	Method getViewFrustum:SViewFrustum()
		Return SViewFrustum.createFromHandle(IrrScene_ICameraSceneNode_getViewFrustum(handle))
	EndMethod
	
	Method isInputReceiverEnabled:Int()
		Return IrrScene_ICameraSceneNode_isInputReceiverEnabled(handle)
	EndMethod
	
	Method setAspectRatio(aspect:Float)
		IrrScene_ICameraSceneNode_setAspectRatio(handle,aspect)
	EndMethod
	
	Method setFarValue(zf:Float)
		IrrScene_ICameraSceneNode_setFarValue(handle,zf)
	EndMethod
	
	Method setFOV(fovy:Float)
		IrrScene_ICameraSceneNode_setFOV(handle,fovy)
	EndMethod
	
	Method setNearValue(nv:Float)
		IrrScene_ICameraSceneNode_setNearValue(handle,nv)
	EndMethod
	
	Method setInputReceiverEnabled(bEnabled:Int)
		IrrScene_ICameraSceneNode_setInputReceiverEnabled(handle,bEnabled)
	EndMethod
	
	Method setProjectionMatrix(projection:Matrix4)
		IrrScene_ICameraSceneNode_setProjectionMatrix(handle,projection.handle)
	EndMethod
	
	Method setTarget(pos:Vector3df)
		IrrScene_ICameraSceneNode_setTarget(handle,pos.handle)
	EndMethod
	
	Method setUpVector(pos:Vector3df)
		IrrScene_ICameraSceneNode_setUpVector(handle,pos.handle)
	EndMethod

	Method OnEvent:Int(event:SEvent)
		Return IrrScene_ICameraSceneNode_OnEvent(handle,event.handle)
	EndMethod

	Method isOrthogonal:Int()
		Return IrrScene_ICameraSceneNode_isOrthogonal(handle)
	EndMethod
	
	Method setIsOrthogonal(bOrthogonal:Int)
		IrrScene_ICameraSceneNode_setIsOrthogonal(handle,bOrthogonal)
	EndMethod

EndType

