' ------------------------------------------------------------------------------------
'  irr::scene::IMeshManipulator wrappers
' ------------------------------------------------------------------------------------
Public

Type IMeshManipulator Extends Tirr_IUnknown Final

	Function createFromHandle:IMeshManipulator(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:IMeshManipulator=New IMeshManipulator
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method createMeshCopy:SMesh(mesh:IMesh)
		'  note: you will need To drop the New mesh pointer
		Return SMesh.createFromHandle(IrrScene_IMeshManipulator_createMeshCopy(handle,mesh.handle))
	EndMethod
	
	Method createMeshWithTangents:IMesh(mesh:IMesh)
		'  note: you will need To drop the New mesh pointer
		Return IMesh.createFromHandle(IrrScene_IMeshManipulator_createMeshWithTangents(handle,mesh.handle))
	EndMethod

	Method createMeshUniquePrimitives:IMesh(mesh:IMesh)
		'  note: you will need To drop the New mesh pointer
		Return IMesh.createFromHandle(IrrScene_IMeshManipulator_createMeshUniquePrimitives(handle,mesh.handle))
	EndMethod

	Method flipSurfaces(mesh:IMesh)
		IrrScene_IMeshManipulator_flipSurfaces(handle,mesh.handle)
	EndMethod
	
	Method getPolyCountFromAnimated:Int(mesh:IAnimatedMesh)
		Return IrrScene_IMeshManipulator_getPolyCountFromAnimated(handle,mesh.handle)
	EndMethod
	
	Method getPolyCount:Int(mesh:IMesh)
		Return IrrScene_IMeshManipulator_getPolyCount(handle,mesh.handle)
	EndMethod
	
	Method makePlanarTextureMapping(mesh:IMesh,resolution:Float=0.001)
		IrrScene_IMeshManipulator_makePlanarTextureMapping(handle,mesh.handle,resolution)
	EndMethod
	
	Method recalculateBoundingBox(buffer:IMeshBuffer)
		IrrScene_IMeshManipulator_recalculateBoundingBox(handle,buffer.handle)
	EndMethod
	
	Method recalculateNormals(mesh:IMesh,bSmooth:Int=False)
		IrrScene_IMeshManipulator_recalculateNormals(handle,mesh.handle,bSmooth)
	EndMethod
	
	Method recalculateNormalsMeshBuffer(buffer:IMeshBuffer,bSmooth:Int=False)
		IrrScene_IMeshManipulator_recalculateNormalsMeshBuffer(handle,buffer.handle,bSmooth)
	EndMethod

	Method scaleMesh(mesh:IMesh,scale:Vector3df)
		IrrScene_IMeshManipulator_scaleMesh(handle,mesh.handle,scale.handle)
	EndMethod
	
	Method setVertexColorAlpha(mesh:IMesh,alpha:Int)
		IrrScene_IMeshManipulator_setVertexColorAlpha(handle,mesh.handle,alpha)
	EndMethod

	Method setVertexColors(mesh:IMesh,color:SColor)
		IrrScene_IMeshManipulator_setVertexColors(handle,mesh.handle,color.handle)
	EndMethod

	Method transformMesh(mesh:IMesh,m:Matrix4)
		IrrScene_IMeshManipulator_transformMesh(handle,mesh.handle,m.handle)
	EndMethod
	
	Method createAnimatedMesh:IAnimatedMesh(mesh:IMesh,E_ANIMATED_MESH_TYPE:Int=EAMT_UNKNOWN)
		Return IAnimatedMesh.createFromHandle(IrrScene_IMeshManipulator_createAnimatedMesh(handle,mesh.handle,E_ANIMATED_MESH_TYPE),True)
	EndMethod
	
	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_IMeshManipulator_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_IMeshManipulator_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_IMeshManipulator_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType



