
extern "C" 
{

//------------------------------------------------------------------------------------
// irr::scene::IMeshManipulator wrappers
//------------------------------------------------------------------------------------

	bool IrrScene_IMeshManipulator_drop(IMeshManipulator* unk)
	{
		if (unk)
			return unk->drop();
		else return 0;
	}
	
	const c8* IrrScene_IMeshManipulator_getDebugName(IMeshManipulator* unk)
	{
		if (unk)
			return unk->getDebugName();
		else return "";
	}
	
	void IrrScene_IMeshManipulator_grab(IMeshManipulator* unk)
	{
		if (unk)
			unk->grab();
	}

	// note: you will need to drop the new mesh pointer
	SMesh* IrrScene_IMeshManipulator_createMeshCopy(IMeshManipulator* mm,IMesh* mesh)
	{
		if (mm)
			return mm->createMeshCopy(mesh);
		else return 0;
	}
	
	// note: you will need to drop the new mesh pointer
	IMesh* IrrScene_IMeshManipulator_createMeshWithTangents(IMeshManipulator* mm,IMesh* mesh)
	{
		if (mm)
			return mm->createMeshWithTangents(mesh);
		else return 0;
	}
	
	IMesh* IrrScene_IMeshManipulator_createMeshUniquePrimitives(IMeshManipulator* mm,IMesh* mesh)
	{
		if (mm)
			return mm->createMeshUniquePrimitives(mesh);
		else return 0;
	}
	
	void IrrScene_IMeshManipulator_flipSurfaces(IMeshManipulator* mm,IMesh* mesh)
	{
		if (mm)
			mm->flipSurfaces(mesh);
	}
	
	s32 IrrScene_IMeshManipulator_getPolyCountFromAnimated(IMeshManipulator* mm,IAnimatedMesh* mesh)
	{
		if (mm)
			return mm->getPolyCount(mesh);
		else return 0;
	}
	
	s32 IrrScene_IMeshManipulator_getPolyCount(IMeshManipulator* mm,IMesh* mesh)
	{
		if (mm)
			return mm->getPolyCount(mesh);
		else return 0;
	}
	
	void IrrScene_IMeshManipulator_makePlanarTextureMapping(IMeshManipulator* mm,IMesh* mesh,f32 resolution=0.001f)
	{
		if (mm)
			mm->makePlanarTextureMapping(mesh,resolution);
	}
	
	void IrrScene_IMeshManipulator_recalculateBoundingBox(IMeshManipulator* mm,IMeshBuffer* buffer)
	{
		if (mm)
			mm->recalculateBoundingBox(buffer);
	}
	
	void IrrScene_IMeshManipulator_recalculateNormals(IMeshManipulator* mm,IMesh* mesh,bool smooth = false)
	{
		if (mm)
			mm->recalculateNormals(mesh,smooth);
	}
	
	void IrrScene_IMeshManipulator_recalculateNormalsMeshBuffer(IMeshManipulator* mm,IMeshBuffer* buffer,bool smooth = false)
	{
		if (mm)
			mm->recalculateNormals(buffer,smooth);
	}
	
	void IrrScene_IMeshManipulator_scaleMesh(IMeshManipulator* mm,IMesh* mesh,vector3df* scale)
	{
		if (mm)
			mm->scaleMesh(mesh,*scale);
	}
	
	void IrrScene_IMeshManipulator_setVertexColorAlpha(IMeshManipulator* mm,IMesh* mesh,s32 alpha)
	{
		if (mm)
			mm->setVertexColorAlpha(mesh,alpha);
	}
	
	void IrrScene_IMeshManipulator_setVertexColors(IMeshManipulator* mm,IMesh* mesh,SColor* color)
	{
		if (mm)
			mm->setVertexColors(mesh,*color);
	}

	void IrrScene_IMeshManipulator_transformMesh(IMeshManipulator* mm,IMesh* mesh, const core::matrix4& m)
	{
		if (mm)
			mm->transformMesh(mesh,m);
	}
	
	IAnimatedMesh* IrrScene_IMeshManipulator_createAnimatedMesh(IMeshManipulator* mm,scene::IMesh* mesh,
		scene::E_ANIMATED_MESH_TYPE type = scene::EAMT_UNKNOWN)
	{
		if (mm)
			return mm->createAnimatedMesh(mesh,type);
		else return 0;
	}
}
