' ------------------------------------------------------------------------------------
'  irr::scene::IParticleSystemSceneNode wrappers (parent is ISceneNode)
' ------------------------------------------------------------------------------------
Public

Type IParticleSystemSceneNode Extends ISceneNodeDefault Final

	Function createFromHandle:IParticleSystemSceneNode(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:IParticleSystemSceneNode=New IParticleSystemSceneNode
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method addAffector(affector:IParticleAffector)			
		IrrScene_IParticleSystemSceneNode_addAffector(handle,affector.handle)
	EndMethod
	
	Method createBoxEmitter:IParticleEmitter(box:AABbox3df=Null,direction:Vector3df=Null,minParticlesPerSecond:Int=5,maxParticlePerSecond:Int=10,minStartColor:SColor=Null,maxStartColor:SColor=Null,lifeTimeMin:Int=2000,lifeTimeMax:Int=4000,maxAngleDegrees:Int=0)
		If box=Null Then box=New AABbox3df ' default handle to 0
		If direction=Null Then direction=New Vector3df ' default handle to 0
		If minStartColor=Null Then minStartColor=New SColor ' default handle to 0
		If maxStartColor=Null Then maxStartColor=New SColor ' default handle to 0	
		Return IParticleEmitter.createFromHandle(IrrScene_IParticleSystemSceneNode_createBoxEmitter(handle,box.handle,direction.handle,minParticlesPerSecond,maxParticlePerSecond,minStartColor.handle,maxStartColor.handle,lifeTimeMin,lifeTimeMax,maxAngleDegrees))
	EndMethod
	
	Method createFadeOutParticleAffector:IParticleAffector(targetColor:SColor=Null,timeNeededToFadeOut:Int=1000)
		If targetColor=Null Then targetColor=New SColor ' default handle to 0
		Return IParticleAffector.createFromHandle(IrrScene_IParticleSystemSceneNode_createFadeOutParticleAffector(handle,targetColor.handle,timeNeededToFadeOut),True)
	EndMethod

	Method createGravityAffector:IParticleAffector(gravity:Vector3df=Null,timeForceLost:Int=1000)
		If gravity=Null Then gravity=New Vector3df ' default handle to 0
		Return IParticleAffector.createFromHandle(IrrScene_IParticleSystemSceneNode_createGravityAffector(handle,gravity.handle,timeForceLost),True)
	EndMethod
	
	Method createPointEmitter:IParticleEmitter(direction:Vector3df=Null,minParticlesPerSecond:Int=5,maxParticlePerSecond:Int=10,minStartColor:SColor=Null,maxStartColor:SColor=Null,lifeTimeMin:Int=2000,lifeTimeMax:Int=4000,maxAngleDegrees:Int=0)
		If direction=Null Then direction=New Vector3df ' default handle to 0
		If minStartColor=Null Then minStartColor=New SColor ' default handle to 0
		If maxStartColor=Null Then maxStartColor=New SColor ' default handle to 0	
		'  you must call drop For this when done.
		Return IParticleEmitter.createFromHandle(IrrScene_IParticleSystemSceneNode_createPointEmitter(handle,direction.handle,minParticlesPerSecond,maxParticlePerSecond,minStartColor.handle,maxStartColor.handle,lifeTimeMin,lifeTimeMax,maxAngleDegrees))
	EndMethod

	Method removeAllAffectors()
		IrrScene_IParticleSystemSceneNode_removeAllAffectors(handle)
	EndMethod
	
	Method setEmitter(emitter:IParticleEmitter=Null)
		If emitter=Null Then emitter=New IParticleEmitter ' default the handle to 0
		IrrScene_IParticleSystemSceneNode_setEmitter(handle,emitter.handle)
	EndMethod
	
	Method setParticlesAreGlobal(bGlobal:Int)
		IrrScene_IParticleSystemSceneNode_setParticlesAreGlobal(handle,bGlobal)
	EndMethod
	
	Method setParticleSize(size:Dimension2df=Null)
		If size=Null Then size=New Dimension2df ' default handle to 0
		IrrScene_IParticleSystemSceneNode_setParticleSize(handle,size.handle)
	EndMethod

EndType
