
Public

Const CSM_TEXTURE_PATH:String = "CSM_TexturePath"
Const LMTS_TEXTURE_PATH:String = "LMTS_TexturePath"
Const MY3D_TEXTURE_PATH:String = "MY3D_TexturePath"
Const COLLADA_CREATE_SCENE_INSTANCES:String = "COLLADA_CreateSceneInstances"
Const DMF_TEXTURE_PATH:String = "DMF_TexturePath"
Const DMF_USE_MATERIALS_DIRS:String = "DMF_MaterialsDir"
Const DMF_FLIP_ALPHA_TEXTURES:String = "DMF_FlipAlpha"
Const DMF_ALPHA_CHANNEL_REF:String = "DMF_AlphaRef"
Const IRR_SCENE_MANAGER_IS_EDITOR:String = "IRR_Editor"

Extern

	' ------------------------------------------------------------------------------------
	'  irr::scene::ISceneManager wrappers
	' ------------------------------------------------------------------------------------
	
	Function IrrScene_ISceneManager_drop:Int(pIUnknown:Int)
	Function IrrScene_ISceneManager_getDebugName$z(pIUnknown:Int)
	Function IrrScene_ISceneManager_grab(pIUnknown:Int)

	Function IrrScene_ISceneManager_createTextureAnimator:Int(pISceneManager_scene:Int,texarray:Int Ptr=Null,texarr_size:Int=0,timePerFrame:Int,bLoop:Int=True) ' returns ISceneNodeAnimator* 
	Function IrrScene_ISceneManager_createFollowSplineAnimator:Int(pISceneManager_scene:Int,startTime:Int,pointsArray:Int Ptr,pointsArraySize:Int,speed:Float=1.0,tightness:Float=0.5) ' returns ISceneNodeAnimator* 
	Function IrrScene_ISceneManager_clear(pISceneManager_scene:Int)
	Function IrrScene_ISceneManager_postEventFromUser:Int(pISceneManager_scene:Int,pSEvent_usrevent:Int)
	Function IrrScene_ISceneManager_addToDeletionQueue(pISceneManager_scene:Int,pISceneNode_node:Int)
	Function IrrScene_ISceneManager_getMeshManipulator:Int(pISceneManager_scene:Int) ' returns IMeshManipulator* 
	Function IrrScene_ISceneManager_getSceneCollisionManager:Int(pISceneManager_scene:Int) ' returns ISceneCollisionManager* 
	Function IrrScene_ISceneManager_addExternalMeshLoader(pISceneManager_scene:Int,pIMeshLoader_externalLoader:Int)
	Function IrrScene_ISceneManager_createMetaTriangleSelector:Int(pISceneManager_scene:Int) ' returns IMetaTriangleSelector* 
	Function IrrScene_ISceneManager_createTerrainTriangleSelector:Int(pISceneManager_scene:Int,pITerrainSceneNode_node:Int,LOD:Int=0) ' returns ITriangleSelector*
	Function IrrScene_ISceneManager_createOctTreeTriangleSelector:Int(pISceneManager_scene:Int,pIMesh_mesh:Int,pISceneNode_node:Int,minimalPolysPerNode:Int=32) ' returns ITriangleSelector* 
	Function IrrScene_ISceneManager_createTriangleSelectorFromBoundingBox:Int(pISceneManager_scene:Int,pISceneNode_node:Int) ' returns ITriangleSelector* 
	Function IrrScene_ISceneManager_createTriangleSelector:Int(pISceneManager_scene:Int,pIMesh_mesh:Int,pISceneNode_node:Int) ' returns ITriangleSelector* 
	Function IrrScene_ISceneManager_createCollisionResponseAnimator:Int(pISceneManager_scene:Int,pITriangleSelector_world:Int,pISceneNode_sceneNode:Int,pvector3df_ellipsoidRadius:Int=0,pvector3df_gravityPerSecond:Int=0,pvector3df_ellipsoidTranslation:Int=0,slidingValue:Float=0.0005) ' returns ISceneNodeAnimatorCollisionResponse* 
	Function IrrScene_ISceneManager_createDeleteAnimator:Int(pISceneManager_scene:Int,timeMs:Int) ' returns ISceneNodeAnimator* 
	Function IrrScene_ISceneManager_createFlyStraightAnimator:Int(pISceneManager_scene:Int,pvector3df_startPoint:Int,pvector3df_endPoint:Int,timeForWay:Int,bLoop:Int=False) ' returns ISceneNodeAnimator* 
	Function IrrScene_ISceneManager_createFlyCircleAnimator:Int(pISceneManager_scene:Int,pvector3df_center:Int,radius:Float,speed:Float=0.001,pvector3df_direction:Int=Null) ' returns ISceneNodeAnimator* 
	Function IrrScene_ISceneManager_createRotationAnimator:Int(pISceneManager_scene:Int,pvector3df_rotpersec:Int) ' returns ISceneNodeAnimator* 
	Function IrrScene_ISceneManager_registerNodeForRendering(pISceneManager_scene:Int,pISceneNode_node:Int,E_SCENE_NODE_RENDER_PASS_pass:Int=ESNRP_AUTOMATIC)
	Function IrrScene_ISceneManager_getShadowColor:Int(pISceneManager_scene:Int) ' returns SColor* 
	Function IrrScene_ISceneManager_setShadowColor(pISceneManager_scene:Int,pSColor_color:Int=0)
	Function IrrScene_ISceneManager_setActiveCamera(pISceneManager_scene:Int,pICameraSceneNode_camera:Int)
	Function IrrScene_ISceneManager_getActiveCamera:Int(pISceneManager_scene:Int) ' returns ICameraSceneNode* 
	Function IrrScene_ISceneManager_getSceneNodeFromId:Int(pISceneManager_scene:Int,id:Int,pISceneNode_start:Int=0) ' returns ISceneNode* 
	Function IrrScene_ISceneManager_getSceneNodeFromName:Int(pISceneManager_scene:Int,name$z,pISceneNode_start:Int=0) ' returns ISceneNode* 	
	Function IrrScene_ISceneManager_getRootSceneNode:Int(pISceneManager_scene:Int) ' returns ISceneNode* 
	Function IrrScene_ISceneManager_addTerrainMesh:Int(pISceneManager_scene:Int,meshname$z,pIImage_texture:Int,pIImage_heightmap:Int,pDimension2df_stretch:Int=0,maxHeight:Float=200.0,pDimension2di_defBlock:Int=0) ' returns IAnimatedMesh* 
	Function IrrScene_ISceneManager_addTerrainSceneNode:Int(pISceneManager_scene:Int,pIReadFile_heightMapFile:Int,pISceneNode_parent:Int=0,id:Int=-1,pVector3df_pos:Int=0,pVector3df_rot:Int=0,pVector3df_scale:Int=0,pSColor_vertexColor:Int=0,maxLOD:Int=5,patchSize:Int=ETPS_17,smoothFactor:Int=0,bAddAlsoIfHeightmapEmpty:Int = false) ' returns ITerrainSceneNode*
	Function IrrScene_ISceneManager_addTerrainSceneNodeFromFile:Int(pISceneManager_scene:Int,heightMapFileName$z,pISceneNode_parent:Int=0,id:Int=-1,pVector3df_pos:Int=0,pVector3df_rot:Int=0,pVector3df_scale:Int=0,pSColor_vertexColor:Int=0,maxLOD:Int=5,patchSize:Int=ETPS_17,smoothFactor:Int=0,bAddAlsoIfHeightmapEmpty:Int = false) ' returns ITerrainSceneNode*
	Function IrrScene_ISceneManager_addHillPlaneMesh:Int(pISceneManager_scene:Int,name$z,pDimension2df_tileSize:Int,pDimension2di_tileCount:Int,pSMaterial_material:Int=0,hillHeight:Float=0.0,pDimension2df_countHills:Int=0,pDimension2df_textureRepeatCount:Int=0) ' returns IAnimatedMesh* 
	Function IrrScene_ISceneManager_addTextSceneNode:Int(pISceneManager_scene:Int,pIGUIFont_font:Int,text$z,pSColor_color:Int=0,pISceneNode_parent:Int=0,pvector3df_pos:Int=0,id:Int=-1) ' returns ITextSceneNode* 
	Function IrrScene_ISceneManager_addDummyTransformationSceneNode:Int(pISceneManager_scene:Int,pISceneNode_parent:Int=0,id:Int=-1) ' returns IDummyTransformationSceneNode* 
	Function IrrScene_ISceneManager_addEmptySceneNode:Int(pISceneManager_scene:Int,pISceneNode_parent:Int=0,id:Int=-1) ' returns ISceneNode* 
	Function IrrScene_ISceneManager_addParticleSystemSceneNode:Int(pISceneManager_scene:Int,bWithDefaultEmitter:Int=True,pISceneNode_parent:Int=0,id:Int=-1,pvector3df_pos:Int=0,pvector3df_rot:Int=0,pvector3df_scale:Int=0) ' returns IParticleSystemSceneNode* 
	Function IrrScene_ISceneManager_addSkyBoxSceneNode:Int(pISceneManager_scene:Int,pITexture_top:Int,pITexture_bottom:Int,pITexture_left:Int,pITexture_right:Int,pITexture_front:Int,pITexture_back:Int,pISceneNode_parent:Int=0,id:Int=-1) ' returns ISceneNode* 
	Function IrrScene_ISceneManager_addBillboardSceneNode:Int(pISceneManager_scene:Int,pISceneNode_parent:Int=0,pDimension2df_size:Int=0,pvector3df_pos:Int=0,id:Int=-1,pSColor_shade_top:Int = 0,pSColor_shade_down:Int = 0) ' returns IBillboardSceneNode* 
	Function IrrScene_ISceneManager_addLightSceneNode:Int(pISceneManager_scene:Int,pISceneNode_parent:Int=0,pvector3df_pos:Int=0,pSColorf_color:Int=0,radius:Float=100.0,id:Int=-1) ' returns ILightSceneNode* 
	Function IrrScene_ISceneManager_addCameraSceneNodeFPS:Int(pISceneManager_scene:Int,pISceneNode_parent:Int=0,rotateSpeed:Float=100.0,moveSpeed:Float=500.0,id:Int=-1,pkeyMapArray:Int Ptr=Null,keyMapSize:Int=0,bNoVerticalMovement:Int=False,jumpSpeed:Float = 0.0) ' returns ICameraSceneNode* 
	Function IrrScene_ISceneManager_addCameraSceneNodeMaya:Int(pISceneManager_scene:Int,pISceneNode_parent:Int=0,rotateSpeed:Float=-1500.0,zoomSpeed:Float=200.0,translationSpeed:Float=1500.0,id:Int=-1) ' returns ICameraSceneNode* 
	Function IrrScene_ISceneManager_addCameraSceneNode:Int(pISceneManager_scene:Int,pISceneNode_parent:Int=0,pvector3df_pos:Int=0,pvector3df_lookat:Int=0,id:Int=-1) ' returns ICameraSceneNode* 
	Function IrrScene_ISceneManager_addOctTreeSceneNode:Int(pISceneManager_scene:Int,pIMesh_mesh:Int,pISceneNode_parent:Int=0,id:Int=-1,minimalPolysPerNode:Int=256,bAlsoAddIfMeshPointerZero:Int=False) ' returns ISceneNode* 
	Function IrrScene_ISceneManager_addAnimatedOctTreeSceneNode:Int(pISceneManager_scene:Int,pIAnimatedMesh_mesh:Int,pISceneNode_parent:Int=0,id:Int=-1,minimalPolysPerNode:Int=128) ' returns ISceneNode* 
	Function IrrScene_ISceneManager_addWaterSurfaceSceneNode:Int(pISceneManager_scene:Int,pIMesh_mesh:Int,waveHeight:Float=2.0,waveSpeed:Float=300.0,waveLength:Float=10.0,pISceneNode_parent:Int=0,id:Int=-1,pvector3df_pos:Int=0,pvector3df_rot:Int=0,pvector3df_scale:Int=0) ' returns ISceneNode* 
	Function IrrScene_ISceneManager_addMeshSceneNode:Int(pISceneManager_scene:Int,pIMesh_mesh:Int,pISceneNode_parent:Int=0,id:Int=-1,pvector3df_pos:Int=0,pvector3df_rot:Int=0,pvector3df_scale:Int=0,bAlsoAddIfMeshPointerZero:Int=False) ' returns ISceneNode* 
	Function IrrScene_ISceneManager_addAnimatedMeshSceneNode:Int(pISceneManager_scene:Int,pIAnimatedMesh_mesh:Int,pISceneNode_parent:Int=0,id:Int=-1,pvector3df_pos:Int=0,pvector3df_rot:Int=0,pvector3df_scale:Int=0,bAlsoAddIfMeshPointerZero:Int=False) ' returns IAnimatedMeshSceneNode* 
	Function IrrScene_ISceneManager_addCubeSceneNode:Int(pISceneManager_scene:Int,size:Float=10.0,pISceneNode_parent:Int=0,id:Int=-1,pvector3df_pos:Int=0,pvector3df_rot:Int=0,pvector3df_scale:Int=0) ' returns ISceneNode* 
	Function IrrScene_ISceneManager_addSphereSceneNode:Int(pISceneManager_scene:Int,radius:Float=5.0,polyCount:Int=16,pISceneNode_parent:Int=0,id:Int=-1,pvector3df_pos:Int=0,pvector3df_rot:Int=0,pvector3df_scale:Int=0) ' returns ISceneNode* 
	Function IrrScene_ISceneManager_getVideoDriver:Int(pISceneManager_scene:Int) ' returns IVideoDriver* 
	Function IrrScene_ISceneManager_getMesh:Int(pISceneManager_scene:Int,filename$z) ' returns IAnimatedMesh* 
	'Function IrrScene_ISceneManager_addMesh(pISceneManager_scene:Int,filename$z,pIAnimatedMesh_mesh:Int)
	Function IrrScene_ISceneManager_drawAll(pISceneManager_scene:Int)
	Function IrrScene_ISceneManager_getMeshCache:Int(pISceneManager:Int) ' returns IMeshCache*
	Function IrrScene_ISceneManager_createNewSceneManager:Int(pISceneManager:Int,bCloneContent:Int=False) ' returns ISceneManager*
	Function IrrScene_ISceneManager_addSkyDomeSceneNode:Int(pISceneManager:Int,pITexture:Int,horiRes:Int,vertRes:Int,texturePercentage:Double,spherePercentage:Double,pISceneNode:Int=0,id:Int=-1) ' returns ISceneNode* 

	Function IrrScene_ISceneManager_getDefaultSceneNodeFactory:Int(pISceneManager:Int) ' returns ISceneNodeFactory*
	Function IrrScene_ISceneManager_registerSceneNodeFactory(pISceneManager:Int,pISceneNodeFactory:Int)
	Function IrrScene_ISceneManager_getRegisteredSceneNodeFactoryCount:Int(pISceneManager:Int)
	Function IrrScene_ISceneManager_getSceneNodeFactory:Int(pISceneManager:Int,index:Int) ' returns ISceneNodeFactory*
	Function IrrScene_ISceneManager_getDefaultSceneNodeAnimatorFactory:Int(pISceneManager:Int) ' returns ISceneNodeAnimatorFactory*
	Function IrrScene_ISceneManager_registerSceneNodeAnimatorFactory(pISceneManager:Int,pISceneNodeAnimatorFactory:Int)
	Function IrrScene_ISceneManager_getRegisteredSceneNodeAnimatorFactoryCount:Int(pISceneManager:Int)
	Function IrrScene_ISceneManager_getSceneNodeAnimatorFactory:Int(pISceneManager:Int,index:Int) ' returns ISceneNodeAnimatorFactory*
	Function IrrScene_ISceneManager_getParameters:Int(pISceneManager:Int) ' returns IAttributes*
	Function IrrScene_ISceneManager_getSceneNodeTypeName$z(pISceneManager:Int,ESCENE_NODE_TYPE:Int)
	Function IrrScene_ISceneManager_saveSceneToFile:Int(pISceneManager:Int,filename$z,pISceneUserDataSerializer:Int=0)
	Function IrrScene_ISceneManager_saveSceneToFileIO:Int(pISceneManager:Int,pIWriteFile:Int,pISceneUserDataSerializer:Int=0)
	Function IrrScene_ISceneManager_loadSceneFromFile:Int(pISceneManager:Int,filename$z, pISceneUserDataSerializer:Int=0)
	Function IrrScene_ISceneManager_loadSceneFromFileIO:Int(pISceneManager:Int,pIReadFile:Int,pISceneUserDataSerializer:Int=0)
	
	Function IrrScene_ISceneManager_setAmbientLight(pISceneManager:Int,pSColorf_ambientColor:Int)
	Function IrrScene_ISceneManager_getAmbientLight:Int(pISceneManager:Int) ' returns SColorf* 

	Function IrrScene_ISceneManager_getGUIEnvironment:Int(pISceneManager:Int) ' returns IGUIEnvironment*
	Function IrrScene_ISceneManager_addQuake3SceneNode:Int(pISceneManager:Int,pIMeshBuffer:Int,pSShader:Int,pISceneNode_parent:Int=0,id:Int=-1) ' returns ISceneNode* 	
	Function IrrScene_ISceneManager_addBillboardTextSceneNode:Int(pISceneManager:Int, ..
		pIGUIFont:Int,text$z,pISceneNode_parent:Int=0,pDimension2df_size:Int=0, ..
		pVector3df_pos:Int=0,id:Int=-1,pSColor_shade_top:Int=0,pSColor_shade_down:Int=0) ' returns ITextSceneNode*
	Function IrrScene_ISceneManager_addArrowMesh:Int(pISceneManager:Int,name$z, ..
			tesselationCylinder:Int,tesselationCone:Int,height:Float, ..
			cylinderHeight:Float,width0:Float,width1:Float, ..
			pSColor_vtxColor0:Int,pSColor_vtxColor1:Int) ' returns IAnimatedMesh*

	Function IrrScene_ISceneManager_getSceneNodeFromType:Int(pISceneManager:Int,ESCENE_NODE_TYPE:Int,pISceneNode_start:Int=0) ' returns ISceneNode*
	Function IrrScene_ISceneManager_addSceneNode:Int(pISceneManager:Int,sceneNodeTypeName$z,pISceneNode_parent:Int) ' returns ISceneNode*
	Function IrrScene_ISceneManager_getSceneNodesFromType:Int(pISceneManager:Int,ESCENE_NODE_TYPE:Int,outNodePtrs:Int Ptr Ptr,pISceneNode_start:Int=0)

EndExtern

