' ------------------------------------------------------------------------------------
'  irr::scene::SMeshBuffer wrappers (parent is IMeshBuffer)
' ------------------------------------------------------------------------------------
' 2005/11/28 - implemented fix from Doug Stastny (Budman) for getVertices()
'

Public

Type SMeshBuffer Extends IMeshBuffer Final

	Function create:SMeshBuffer()
		Return createFromHandle(IrrScene_SMeshBuffer_new(),True)
	EndFunction
	
	Function createFromHandle:SMeshBuffer(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMeshBuffer=New SMeshBuffer
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
		
	Method getBoundingBox:AABbox3df()
		Return AABbox3df.createFromHandle(IrrScene_SMeshBuffer_getBoundingBox(handle),True)
	EndMethod
	
	Method getIndexCount:Int()
		Return IrrScene_SMeshBuffer_getIndexCount(handle)
	EndMethod
	
	Method getIndices:Array_u16()
		'  do not delete this pointer
		Return Array_u16.createFromHandle(IrrScene_SMeshBuffer_getIndices(handle),False)
	EndMethod
	
	Method getMaterial:SMaterial()
		'  do Not Delete this pointer
		Return SMaterial.createFromHandle(IrrScene_SMeshBuffer_getMaterial(handle),False)
	EndMethod
	
	Method getVertexCount:Int()
		Return IrrScene_SMeshBuffer_getVertexCount(handle)
	EndMethod
	
	Method getVertexType:Int()
		Return IrrScene_SMeshBuffer_getVertexType(handle)
	EndMethod
	
	Method getVertices:Array_S3DVertex()
		'  do not delete this pointer
		' dbs changed should have passed false
		Return Array_S3DVertex.createFromHandle(IrrScene_SMeshBuffer_getVertices(handle),False)
	EndMethod
	
	Method recalculateBoundingBox()
		IrrScene_SMeshBuffer_recalculateBoundingBox(handle)
	EndMethod
	
	Method getVertexPitch:Int()
		Return IrrScene_SMeshBuffer_getVertexPitch(handle)
	EndMethod
	
	Method setBoundingBox(box:AABbox3df)
		IrrScene_SMeshBuffer_setBoundingBox(handle,box.handle)
	EndMethod
	
EndType