//------------------------------------------------------------------------------------
// irr::scene::SMeshBuffer wrappers (parent is IMeshBuffer)
//------------------------------------------------------------------------------------
extern "C" 
{
	SMeshBuffer* IrrScene_SMeshBuffer_new()
	{
		return new SMeshBuffer();
	}
	
	// do not delete this pointer
	aabbox3d<f32>* IrrScene_SMeshBuffer_getBoundingBox(SMeshBuffer* mb)
	{
		if (mb)
			return new aabbox3d<f32>(mb->getBoundingBox());
		else return 0;
	}
	
	u32 IrrScene_SMeshBuffer_getIndexCount(SMeshBuffer* mb)
	{
		if (mb)
			return mb->getIndexCount();
		else return 0;
	}
	
	// do not delete this pointer
	array<u16>* IrrScene_SMeshBuffer_getIndices(SMeshBuffer* mb)
	{
		if (mb)
			return &mb->Indices;
		else return 0;
	}
	
	// do not delete this pointer
	SMaterial* IrrScene_SMeshBuffer_getMaterial(SMeshBuffer* mb)
	{
		if (mb)
			return &mb->getMaterial();
		else return 0;
	}
	
	u32 IrrScene_SMeshBuffer_getVertexCount(SMeshBuffer* mb)
	{
		if (mb)
			return mb->getVertexCount();
		else return 0;
	}
	
	s32 IrrScene_SMeshBuffer_getVertexType(SMeshBuffer* mb)
	{
		if (mb)
			return mb->getVertexType();
		else return -1;
	}
	
	// do not delete this pointer
	array<S3DVertex>* IrrScene_SMeshBuffer_getVertices(SMeshBuffer* mb)
	{
		if (mb)
			return &mb->Vertices;
		else return 0;
	}
	
	void IrrScene_SMeshBuffer_recalculateBoundingBox(SMeshBuffer* mb)
	{
		if (mb)
			mb->recalculateBoundingBox();
	}
	
	u32 IrrScene_SMeshBuffer_getVertexPitch(SMeshBuffer* mb)
	{
		if (mb)
			return mb->getVertexPitch();
		else return -1;
	}

	void IrrScene_SMeshBuffer_setBoundingBox(SMeshBuffer* mb,const core::aabbox3df& box)
	{
		if (mb)
			mb->setBoundingBox(box);
	}
	
}