' ------------------------------------------------------------------------------------
'  irr::scene::SMeshBufferTangents wrappers (parent is IMeshBuffer)
' ------------------------------------------------------------------------------------
Public

Type SMeshBufferTangents Extends IMeshBuffer Final

	Function create:SMeshBufferTangents()
		Return createFromHandle(IrrScene_SMeshBufferTangents_new(),True)
	EndFunction

	Function createFromHandle:SMeshBufferTangents(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMeshBufferTangents=New SMeshBufferTangents
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
		
	Method getBoundingBox:AABBox3df()
		Return AABbox3df.createFromHandle(IrrScene_SMeshBufferTangents_getBoundingBox(handle),True)
	EndMethod

	Method getIndexCount:Int()
		Return IrrScene_SMeshBufferTangents_getIndexCount(handle)
	EndMethod

	Method getIndices:Array_u16()
		'  do Not Delete this pointer
		Return Array_u16.createFromHandle(IrrScene_SMeshBufferTangents_getIndices(handle),False)
	EndMethod

	Method getMaterial:SMaterial()
		'  do Not Delete this pointer
		Return SMaterial.createFromHandle(IrrScene_SMeshBufferTangents_getMaterial(handle),False)
	EndMethod

	Method getVertexCount:Int()
		Return IrrScene_SMeshBufferTangents_getVertexCount(handle)
	EndMethod
	
	Method getVertexType:Int()
		Return IrrScene_SMeshBufferTangents_getVertexType(handle)
	EndMethod

	Method getVertices_SMBT:Array_S3DVertexTangents()
		'  returns a pointer To array of S3DVertexTangents. do Not Delete this pointer
		Return Array_S3DVertexTangents.createFromHandle(IrrScene_SMeshBufferTangents_getVertices(handle),False)
	EndMethod

	Method recalculateBoundingBox()
		IrrScene_SMeshBufferTangents_recalculateBoundingBox(handle)
	EndMethod

	Method setBoundingBox(box:AABbox3df)
		IrrScene_SMeshBufferTangents_setBoundingBox(handle,box.handle)
	EndMethod
	
	Method getVertexPitch:Int()
		Return IrrScene_SMeshBufferTangents_getVertexPitch(handle)
	EndMethod
	
EndType

